/*
 * Uility for access i2c device trought console
 *
 *
 * (C) Copyright 2008, Claudio Mignanti
 *
 * This program is free software; you can redistribute it and/or
 * modify it under the terms of the GNU General Public License
 * as published by the Free Software Foundation; either
 * version 2 of the License, or (at your option) any later
 * version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program; if not, write to the Free Software
 * Foundation, Inc., 51 Franklin St, Fifth Floor, Boston, MA  02110-1301  USA
 *
 */

#include <fcntl.h>
#include <stdio.h>
#include <stdlib.h>
#include <sys/ioctl.h>
#include <string.h>
#include <unistd.h>
#include <errno.h>
#include <asm/etraxi2c.h>


void usage(void) 
{
	fprintf(stderr, "Usage:\n\t i2ccmd {-w -d <data>|-r} -a <slave address> -c <slave register>\n");
	exit(1);
}

int main(int argc, char **argv)
{
	int opt;
	int ot=0;
	int addr, data, reg;
	int fd, i2c_arg;

	while ((opt = getopt(argc, argv, "wra:d:c:")) != -1) {
		switch(opt) {
			case 'w':
				ot=1;
				break;
			case 'r':
				ot=2;
				break;
			case 'a':
			{
				addr = atoi(optarg);
				if ((addr == 0) || (addr > 255)) {
					usage();
				}
				break;
			}
			case 'c':
			{
				reg = atoi(optarg);
				if ((reg == 0) || (reg > 255)) {
					usage();
				}
				break;
			}
			case 'd':
			{
				data = atoi(optarg);
				if ((data == 0) || (data > 255)) {
					usage();
				}
				break;
			}
			default:
				usage();
		}
	}

	if ( fd = open("/dev/i2c", O_RDWR) < 0) {
		int err_saved = errno;
		perror("Try to load i2c modules");
		exit(1);
	}
	if ( ot == 1 ) {
	//write data to i2c device
		i2c_arg = I2C_WRITEARG(addr, reg, data);
		int r = ioctl(fd, _IO(ETRAXI2C_IOCTYPE, I2C_WRITEREG), i2c_arg);
		if (r < 0)
			fprintf (stderr, "Error writing data on %d[%d]", addr, reg);

	} else 
	if ( ot == 2 ) {
	//read data from i2c device
		i2c_arg = I2C_READARG(addr, reg);
		int r = ioctl(fd, _IO(ETRAXI2C_IOCTYPE, I2C_READREG), i2c_arg);
		if (r < 0)
			fprintf (stderr, "Error writing data on %d[%d]", addr, reg);
		else {
			printf ("%d\n", r);
			exit(r);
		}
	} else
		usage();

	return 0;
}






